<app-header-catalog
  [catalog]="'dataset'"
  [label]="label"
  [description]="description"
  [breadcrumb]="breadcrumb"
/>

<div [ngClass]="['dataset-page', jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="jds.row">
      <aside [ngClass]="[jds.col(3)]">
        <jds-bi-accordion
          #acc="jdsBiAccordion"
          [destroyOnHide]="true"
          [closeOthers]="false"
          [activeIds]="[
            'accordion-organization',
            'accordion-topic',
            'accordion-classification',
            'accordion-quality-data',
            'accordion-dataset-tags',
            'accordion-license'
          ]"
          colorScheme="blue"
        >
          <!-- Filter Organization Satu Data -->
          <jds-bi-panel
            id="accordion-organization"
            title="Organisasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listOrganizationSatuData(); as listOrgSatuData) {
                @switch (listOrgSatuData.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-organization
                      [data]="listOrgSatuData.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Topic Satu Data -->
          <jds-bi-panel
            id="accordion-topic"
            title="Topik"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listTopicSatuData(); as listTopicSatuData) {
                @switch (listTopicSatuData.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-topic
                      [data]="listTopicSatuData.data.list"
                      [filter]="vm.filterTopic()"
                      (filterChange)="vm.handleFilterTopic($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Classification Dataset -->
          <jds-bi-panel
            id="accordion-classification"
            title="Klasifikasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listClassification(); as listClass) {
                @switch (listClass.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-classification
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Quality Data -->
          <jds-bi-panel
            id="accordion-quality-data"
            title="Kualitas Data"
          >
            <ng-template jdsBiPanelContent>
              <app-filter-quality
                [data]="vm.listDatasetQuality()"
                [filter]="vm.filterQuality()"
                (filterChange)="vm.handleFilterQuality($event)"
              />
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Tags -->
          <jds-bi-panel
            id="accordion-dataset-tags"
            title="Tags"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listDatasetTags(); as listDatasetTags) {
                @switch (listDatasetTags.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-dataset-tags
                      [data]="listDatasetTags.data.list"
                      [filter]="vm.filterTags()"
                      (filterChange)="vm.handleFilterTags($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter License -->
          <jds-bi-panel
            id="accordion-license"
            title="Lisensi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listDatasetLicense(); as listDatasetLicense) {
                @switch (listDatasetLicense.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-license
                      [data]="listDatasetLicense.data.list"
                      [filter]="vm.filterLicense()"
                      (filterChange)="vm.handleFilterLicense($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>
        </jds-bi-accordion>
      </aside>

      <div [ngClass]="[jds.col(9)]">
        <!-- Search Catalog -->
        <div [ngClass]="[jds.mb(16)]">
          <app-search-catalog
            [catalog]="'dataset'"
            [search]="vm.filterSearch()"
            (searchChange)="vm.handleFilterSearch($event)"
          />
        </div>

        <div
          [ngClass]="[
            jds.d('flex'),
            jds.alignItems('center'),
            jds.justifyContent('between'),
            jds.mb(24)
          ]"
        >
          <!-- Suggestion Catalog -->
          @if (vm.listDataset(); as listDataset) {
            @switch (listDataset.status) {
              @case ('loading') {
                <div class="wrapper-skeleton">
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '25%',
                      'border-radius': '0',
                      height: '22px',
                      'margin-bottom': '0'
                    }"
                  />
                </div>
              }
              @case ('success') {
                @if (listDataset.data.list.length > 0) {
                  <span [ngClass]="[jds.fs(14)]">
                    <strong>
                      {{
                        listDataset.data.pagination.total_items
                          | number: '1.0-0' : 'id'
                      }}
                    </strong>
                    Dataset ditemukan
                  </span>
                } @else {
                  <span [ngClass]="[jds.fs(14)]">
                    Dataset tidak ditemukan
                  </span>
                }
              }
            }
          }

          <!-- Sort Catalog -->
          <app-sort-catalog
            [catalog]="'dataset'"
            [sort]="vm.filterSort()"
            (sortChange)="vm.handleFilterSort($event)"
          />
        </div>

        <!-- Quick Access Catalog -->
        @if (vm.hasFilterQuickAccess()) {
          <div [ngClass]="[vm.hasFilterQuickAccess() ? jds.mb(16) : '']">
            <div [ngClass]="jds.d('flex')">
              <div [ngClass]="[jds.minW(100), jds.leading(32)]">
                <span>Filter Aktif: </span>
              </div>
              <div>
                <!-- Quick Access Organization -->
                @if (vm.listOrganizationSatuData(); as listOrgSatuData) {
                  @if (listOrgSatuData.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'organization'"
                      [data]="listOrgSatuData.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }

                <!-- Quick Access Topic -->
                @if (vm.listTopicSatuData(); as listTopicSatuData) {
                  @if (listTopicSatuData.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'topic'"
                      [data]="listTopicSatuData.data.list"
                      [filter]="vm.filterTopic()"
                      (filterChange)="vm.handleFilterTopic($event)"
                    />
                  }
                }

                <!-- Quick Access Classification -->
                @if (vm.listClassification(); as listClass) {
                  @if (listClass.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'classification'"
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }

                <!-- Quick Access Quality Data -->
                <app-quick-access-catalog
                  [type]="'quality'"
                  [data]="vm.listDatasetQuality()"
                  [filter]="vm.filterQuality()"
                  (filterChange)="vm.handleFilterQuality($event)"
                />

                <!-- Quick Access Tags -->
                @if (vm.listDatasetTags(); as listDatasetTags) {
                  @if (listDatasetTags.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'dataset-tags'"
                      [data]="listDatasetTags.data.list"
                      [filter]="vm.filterTags()"
                      (filterChange)="vm.handleFilterTags($event)"
                    />
                  }
                }

                <!-- Quick Access License -->
                @if (vm.listDatasetLicense(); as listDatasetLicense) {
                  @if (listDatasetLicense.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'license'"
                      [data]="listDatasetLicense.data.list"
                      [filter]="vm.filterLicense()"
                      (filterChange)="vm.handleFilterLicense($event)"
                    />
                  }
                }

                <button
                  [size]="'sm'"
                  [ngClass]="[jds.me(8), jds.mb(8)]"
                  [variant]="'ghost'"
                  [colorScheme]="colorScheme"
                  (click)="vm.handleFilterClear()"
                  jdsBiButton
                  type="button"
                >
                  Hapus Semua
                </button>
              </div>
            </div>
          </div>
        }

        <!-- List Catalog Dataset -->
        @if (vm.listDataset(); as listDataset) {
          @switch (listDataset.status) {
            @case ('loading') {
              <app-skeleton-catalog />
            }
            @case ('success') {
              @if (listDataset.isFetching) {
                <app-skeleton-catalog />
              } @else if (listDataset.data.list.length > 0) {
                @for (item of listDataset.data.list; track item.id) {
                  <app-list-dataset
                    [isAction]="false"
                    [data]="item"
                    [filterTag]="vm.filterTags()"
                    (filterTagChange)="vm.handleFilterTags($event)"
                  />
                }

                <jds-bi-pagination
                  [colorScheme]="colorScheme"
                  [perPageItems]="perPageItems"
                  [pagination]="listDataset.data.pagination"
                  [perPage]="vm.filterPerPage()"
                  [page]="vm.filterCurrentPage()"
                  (filterPerPage)="vm.handleFilterPerPage($event)"
                  (filterPage)="vm.handleFilterCurrentPage($event)"
                />
              } @else {
                @if (vm.hasFilterSearch()) {
                  <app-list-empty type="dataset">
                    <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                    <p>
                      Dataset yang Anda cari tidak ditemukan atau terjadi
                      kesalahan penulisan kata kunci.
                    </p>
                  </app-list-empty>
                } @else {
                  <app-list-empty type="dataset">
                    <h6>Maaf, belum ada Dataset yang dapat diakses.</h6>
                    <p>
                      Mohon coba kembali di lain waktu untuk mendapatkan Dataset
                      yang Anda cari.
                    </p>
                  </app-list-empty>
                }
              }
            }
          }
        }
      </div>
    </div>
  </div>
</div>
